**    ModelEco : MODELisation en programmation mathmatique pour l'analyse ECOnomique de l'agriculure    **

*-----------------------------------------------------------------------------*
$Ontext
Nom              ExploitationFamiliale_4
Sequence         1 - Initiation  la programmation mathmatique avec GAMS
Langage GAMS
Type             LP
Description Initial Model

 " A farmer owns 5 ha of land. His family can provide the equivalent of 5 people per year in terms of working time. The number of working days per year and per person is estimated at 100. This farmer can choose between 4 agricultural activities whose costs, yields and prices are shown in the table below. The currency is the rupee."
ACTIVITIES        Wheat        Rice        Sugar cane        Livestock
YIELD
(Tons/ha or
Rupees/ha for livestock)         9        6        18        17000
COSTS(Rupees/ha)        3120        5480        11360        5000
PRICE(Rupees/ton)        990        3276        1686        1
For livestock, the value shown in the yield row directly measures the gross product per hectare. A value of 1 was therefore provided in the price line.
The table below compiles the resource needs for each activity.
ACTIVITIES        Wheat        Rice        Sugar cane        Livestock
Labour(days/year/ha)        40.5        96        282        159
The objective of the farmer is to maximize the global gross margin."

$Offtext

*----------                          INDICES                        ----------*
SET
C / wheat, rice, cane, livestock/
;

*----------                          DONNEES                        ----------*
SCALAR
LF       labour force                                    /500/
UAA      Utilized Agricultural Area                      /5/
WA       Water availability                              /7000/
WAPrice  Water Price                                     /2/
CASH     cash flow limit                                /20000/

;

PARAMETER
Y(C)     Crop yields
/wheat       9
 rice        6
 cane        18
 livestock   17000/

CO(C)    Operational crop costs
/wheat      3120
 rice       5480
 cane       11360
 livestock  5000/

P(C)     Crop sale prices
/wheat       990
 rice        3276
 cane        1686
 livestock   1/

LabourN(C) Crop labour needs
/wheat       40.5
 rice        96
 cane        282
 livestock   159/

WaterN(C)  Crop water needs
/wheat       740
 rice        3000
 cane        2200
 livestock   1100/
;

PARAMETER
GM(C)    gross margin
;
GM(C)= P(C)*Y(C)-CO(C);

display GM ;

*----------                         MODELE                          ----------*
VARIABLES
Z
;
POSITIVE VARIABLES
X          Area dedicated to crops
PurchW     purchased water
;

EQUATIONS
objective  objective function
land       land constraint
labour     labour constraint
irrigation irrigation constraint
cashflow   cashflow constraint
;


objective ..   sum(C, X(C)*GM(C)) -PurchW*WAPrice =e= Z;

land ..        sum(C, X(C)) =l= UAA;

labour ..      sum (C, X(C)*LabourN(C)) =l= LF;

irrigation ..  sum(C,X(C)*WaterN(C)) =l= WA + PurchW;

cashflow..     sum(C,X(C)*CO(C)) + PurchW*WAPrice =l= CASH ;

model ex4 /all/;

*----------                        SOLUTION                         ----------*
solve ex4 using LP maximizing Z;
